diff -uNr ntop-3.3.8/COPYING ntop-3.3.9/COPYING
--- ntop-3.3.8/COPYING	2008-10-02 12:54:15.000000000 +0200
+++ ntop-3.3.9/COPYING	2008-12-03 23:00:22.000000000 +0100
@@ -628,15 +287,15 @@
 
   To do so, attach the following notices to the program.  It is safest
 to attach them to the start of each source file to most effectively
-state the exclusion of warranty; and each file should have at least
+convey the exclusion of warranty; and each file should have at least
 the "copyright" line and a pointer to where the full notice is found.
 
     <one line to give the program's name and a brief idea of what it does.>
     Copyright (C) <year>  <name of author>
 
-    This program is free software: you can redistribute it and/or modify
+    This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
-    the Free Software Foundation, either version 3 of the License, or
+    the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.
 
     This program is distributed in the hope that it will be useful,
@@ -645,30 +304,37 @@
     GNU General Public License for more details.
 
     You should have received a copy of the GNU General Public License
-    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+    along with this program; if not, write to the Free Software
+    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
+
 
 Also add information on how to contact you by electronic and paper mail.
 
-  If the program does terminal interaction, make it output a short
-notice like this when it starts in an interactive mode:
+If the program is interactive, make it output a short notice like this
+when it starts in an interactive mode:
 
-    <program>  Copyright (C) <year>  <name of author>
-    This program comes with ABSOLUTELY NO WARRANTY; for details type `show w'.
+    Gnomovision version 69, Copyright (C) year  name of author
+    Gnomovision comes with ABSOLUTELY NO WARRANTY; for details type `show w'.
     This is free software, and you are welcome to redistribute it
     under certain conditions; type `show c' for details.
 
 The hypothetical commands `show w' and `show c' should show the appropriate
-parts of the General Public License.  Of course, your program's commands
-might be different; for a GUI interface, you would use an "about box".
-
-  You should also get your employer (if you work as a programmer) or school,
-if any, to sign a "copyright disclaimer" for the program, if necessary.
-For more information on this, and how to apply and follow the GNU GPL, see
-<http://www.gnu.org/licenses/>.
-
-  The GNU General Public License does not permit incorporating your program
-into proprietary programs.  If your program is a subroutine library, you
-may consider it more useful to permit linking proprietary applications with
-the library.  If this is what you want to do, use the GNU Lesser General
-Public License instead of this License.  But first, please read
-<http://www.gnu.org/philosophy/why-not-lgpl.html>.
+parts of the General Public License.  Of course, the commands you use may
+be called something other than `show w' and `show c'; they could even be
+mouse-clicks or menu items--whatever suits your program.
+
+You should also get your employer (if you work as a programmer) or your
+school, if any, to sign a "copyright disclaimer" for the program, if
+necessary.  Here is a sample; alter the names:
+
+  Yoyodyne, Inc., hereby disclaims all copyright interest in the program
+  `Gnomovision' (which makes passes at compilers) written by James Hacker.
+
+  <signature of Ty Coon>, 1 April 1989
+  Ty Coon, President of Vice
+
+This General Public License does not permit incorporating your program into
+proprietary programs.  If your program is a subroutine library, you may
+consider it more useful to permit linking proprietary applications with the
+library.  If this is what you want to do, use the GNU Library General
+Public License instead of this License.
diff -uNr ntop-3.3.8/depcomp ntop-3.3.9/depcomp
--- ntop-3.3.8/depcomp	2008-10-02 12:54:15.000000000 +0200
+++ ntop-3.3.9/depcomp	2008-12-03 23:00:22.000000000 +0100
@@ -1,9 +1,9 @@
 #! /bin/sh
 # depcomp - compile a program generating dependencies as side-effects
 
-scriptversion=2007-03-29.01
+scriptversion=2006-10-15.18
 
-# Copyright (C) 1999, 2000, 2003, 2004, 2005, 2006, 2007 Free Software
+# Copyright (C) 1999, 2000, 2003, 2004, 2005, 2006 Free Software
 # Foundation, Inc.
 
 # This program is free software; you can redistribute it and/or modify
@@ -215,39 +215,34 @@
   # current directory.  Also, the AIX compiler puts `$object:' at the
   # start of each line; $object doesn't have directory information.
   # Version 6 uses the directory in both cases.
-  dir=`echo "$object" | sed -e 's|/[^/]*$|/|'`
-  test "x$dir" = "x$object" && dir=
-  base=`echo "$object" | sed -e 's|^.*/||' -e 's/\.o$//' -e 's/\.lo$//'`
+  stripped=`echo "$object" | sed 's/\(.*\)\..*$/\1/'`
+  tmpdepfile="$stripped.u"
   if test "$libtool" = yes; then
-    tmpdepfile1=$dir$base.u
-    tmpdepfile2=$base.u
-    tmpdepfile3=$dir.libs/$base.u
     "$@" -Wc,-M
   else
-    tmpdepfile1=$dir$base.u
-    tmpdepfile2=$dir$base.u
-    tmpdepfile3=$dir$base.u
     "$@" -M
   fi
   stat=$?
 
+  if test -f "$tmpdepfile"; then :
+  else
+    stripped=`echo "$stripped" | sed 's,^.*/,,'`
+    tmpdepfile="$stripped.u"
+  fi
+
   if test $stat -eq 0; then :
   else
-    rm -f "$tmpdepfile1" "$tmpdepfile2" "$tmpdepfile3"
+    rm -f "$tmpdepfile"
     exit $stat
   fi
 
-  for tmpdepfile in "$tmpdepfile1" "$tmpdepfile2" "$tmpdepfile3"
-  do
-    test -f "$tmpdepfile" && break
-  done
   if test -f "$tmpdepfile"; then
+    outname="$stripped.o"
     # Each line is of the form `foo.o: dependent.h'.
     # Do two passes, one to just change these to
     # `$object: dependent.h' and one to simply `dependent.h:'.
-    sed -e "s,^.*\.[a-z]*:,$object:," < "$tmpdepfile" > "$depfile"
-    # That's a tab and a space in the [].
-    sed -e 's,^.*\.[a-z]*:[	 ]*,,' -e 's,$,:,' < "$tmpdepfile" >> "$depfile"
+    sed -e "s,^$outname:,$object :," < "$tmpdepfile" > "$depfile"
+    sed -e "s,^$outname: \(.*\)$,\1:," < "$tmpdepfile" >> "$depfile"
   else
     # The sourcefile does not contain any dependencies, so just
     # store a dummy comment line, to avoid errors with the Makefile
diff -uNr ntop-3.3.8/globals-core.c ntop-3.3.9/globals-core.c
--- ntop-3.3.8/globals-core.c	2008-10-01 23:03:36.000000000 +0200
+++ ntop-3.3.9/globals-core.c	2008-12-03 23:00:22.000000000 +0100
@@ -210,7 +210,6 @@
     exit(-1);
   }
 
-
   /* Databases */
   myGlobals.dnsCacheFile = NULL;
   myGlobals.pwFile = NULL;
@@ -341,6 +340,7 @@
   createMutex(&myGlobals.queueAddressMutex);
 
   createMutex(&myGlobals.gdbmMutex);        /* data to synchronize thread access to db files */
+  createMutex(&myGlobals.portsMutex);       /* Avoid race conditions while handling ports */
 
   for(i=0; i<NUM_SESSION_MUTEXES; i++)
     createMutex(&myGlobals.tcpSessionsMutex[i]); /* data to synchronize TCP sessions access */
@@ -642,6 +642,8 @@
   addNewIpProtocolToHandle("OSPF", 89, 0 /* no proto */);
   addNewIpProtocolToHandle("IPsec", 50, 51);
 
+  init_maps();
+
   if(fetchPrefsValue("globals.displayPolicy", value, sizeof(value)) == -1) {
     myGlobals.hostsDisplayPolicy = showAllHosts /* 0 */;
     storePrefsValue("globals.displayPolicy", "0");
diff -uNr ntop-3.3.8/globals-core.h ntop-3.3.9/globals-core.h
--- ntop-3.3.8/globals-core.h	2008-10-01 23:03:36.000000000 +0200
+++ ntop-3.3.9/globals-core.h	2008-11-07 12:04:30.000000000 +0100
@@ -727,7 +727,6 @@
 extern u_int numActiveVsans(u_int deviceId);
 extern u_int32_t xaton(char *s);
 extern void* addNodeInternal(u_int32_t ip, int prefix, char *country, int as);
-extern char *ip2CountryCode(HostAddr ip);
 extern short addrcmp(HostAddr *addr1, HostAddr *addr2);
 extern HostAddr     * addrcpy(HostAddr *dst, HostAddr *src);
 extern int            addrinit(HostAddr *addr);
@@ -742,7 +741,6 @@
 extern u_int16_t computeTransId(HostAddr *srcAddr, HostAddr *dstAddr,
 				int sport, int dport);
 extern int setSpecifiedUser(void);
-extern u_short ip2AS(HostAddr ip);
 extern u_int16_t getHostAS(HostTraffic *el);
 extern int emptySerial(HostSerial *a);
 extern int cmpSerial(HostSerial *a, HostSerial *b);
diff -uNr ntop-3.3.8/globals-defines.h ntop-3.3.9/globals-defines.h
--- ntop-3.3.8/globals-defines.h	2008-10-02 12:54:15.000000000 +0200
+++ ntop-3.3.9/globals-defines.h	2008-12-09 12:41:47.000000000 +0100
@@ -946,11 +946,6 @@
 #define CONST_ASLIST_FILE                   "AS-list.txt"
 
 /*
- * IP to CountryCode file
- */
-#define CONST_P2C_FILE                      "p2c.opt.table"
-
-/*
  * libgd file name
  */
 #define CONST_LIBGD_SO                      "libgd.so"
@@ -1057,6 +1052,11 @@
 /* #define MAX_NETFLOW_PACKET_BUFFER           16  */
 
 /*
+	http://code.google.com/apis/maps/
+*/
+#define GOOGLE_DEFAULT_MAP_KEY "ABQIAAAAfFZuochHQVROgoyQEe3_SBS6yewdwLQqdZ11GEdkGrSPz1gWRxTmFdYiXZrTS3LFawwiK5Pufj5j1Q"
+
+/*
  * FibreChannel/SCSI constants
  */
 
@@ -1185,6 +1185,7 @@
 #define CONST_PRIVACYFORCE_HTML             "privacyFlagForce.html"
 #define CONST_PRIVACYNOTICE_HTML            "privacyNotice.html"
 #define CONST_PURGE_HOST                    "purgeHost.html"
+#define CONST_HOST_MAP                      "hostMap.html"
 #define CONST_RESET_STATS_HTML              "resetStats.html"
 #define CONST_SCSI_BYTES_HTML               "ScsiBytes.html"
 #define CONST_BAR_LUNSTATS_DIST             "ScsiBytesLunDistribution"
@@ -1610,7 +1611,7 @@
 #define CONST_IMG_FIBRECHANNEL_SWITCH  "<img class=tooltip src=\"/switch.gif\" border=\"0\" alt=\"FibreChannel Switch\" title=\"FibreChannel Switch\">"
 #define CONST_IMG_DHCP_CLIENT          "<img class=tooltip src=\"/bulb.gif\" border=\"0\" alt=\"DHCP Client\" title=\"DHCP Client\">"
 #define CONST_IMG_DHCP_SERVER          "<img class=tooltip src=\"/antenna.gif\" border=\"0\" alt=\"DHCP Server\" title=\"DHCP Server\">"
-#define CONST_IMG_MULTIHOMED           "<img class=tooltip src=\"/multihomed.gif\" border=\"0\" alt=\"Multihomed\" title=\"Multihomed\">"
+#define CONST_IMG_MULTIHOMED           "<img class=tooltip src=\"/multihomed.png\" border=\"0\" alt=\"Multihomed\" title=\"Multihomed\">"
 #define CONST_IMG_MULTIVLANED          "<img class=tooltip src=\"/multivlaned.gif\"\" border=\"0\" alt=\"Multivlaned\" title=\"Multivlaned\">"
 #define CONST_IMG_BRIDGE               "<img class=tooltip src=\"/bridge.gif\" border=\"0\" alt=\"Bridge\" title=\"Bridge\">"
 #define CONST_IMG_ROUTER               "<img class=tooltip src=\"/router.gif\" border=\"0\" alt=\"Router\" title=\"Router\">"
@@ -2104,7 +2105,11 @@
  */
 #define DEFAULT_TRACE_LEVEL                 3
 
+#if 0
 #define DEFAULT_NTOP_MAPPER_URL             "http://www.ntop.org/cgi-bin/mapper.pl" /* -U -*/
+#else
+#define DEFAULT_NTOP_MAPPER_URL             "http://geotool.servehttp.com/" /* -U -*/
+#endif
 
 #ifdef MAKE_WITH_SCHED_YIELD
 #define DEFAULT_NTOP_SCHED_YIELD            TRUE
@@ -2805,6 +2810,10 @@
 #define IP_TCP_PORT_JETDIRECT      9100
 #define IP_TCP_PORT_SKYPE          54045
 
+/* GeoIP - http://www.maxmind.com */
+#define GEO_IP_FILE                "GeoLiteCity.dat"
+#define GEO_IP_ASN_FILE            "GeoIPASNum.dat"
+
 #define NULL_VALUE                 "(null)"
 
 /* NTOP preference names */
diff -uNr ntop-3.3.8/globals-report.h ntop-3.3.9/globals-report.h
--- ntop-3.3.8/globals-report.h	2008-07-21 00:40:06.000000000 +0200
+++ ntop-3.3.9/globals-report.h	2008-11-07 01:56:35.000000000 +0100
@@ -362,3 +362,7 @@
 extern void drawVsanSwilsProtoDistribution(u_short vsanId);
 
 extern int handlePerlHTTPRequest(char *url);
+
+/* map.c */
+extern void init_maps(void);
+extern void create_host_map(void);
diff -uNr ntop-3.3.8/globals-structtypes.h ntop-3.3.9/globals-structtypes.h
--- ntop-3.3.8/globals-structtypes.h	2008-08-11 01:05:06.000000000 +0200
+++ ntop-3.3.9/globals-structtypes.h	2008-12-03 23:00:22.000000000 +0100
@@ -835,6 +835,7 @@
   u_int16_t        vlanId;          /* VLAN Id (-1 if not set) */
   u_int16_t        ifId;            /* Interface Id [e.g. for NetFlow] (-1 if not set) */
   u_int16_t        hostAS;          /* AS to which the host belongs to */
+  char             *hostASDescr;    /* Description of the host AS */
   time_t           firstSeen, lastSeen; /* time when this host has sent/rcvd some data  */
   u_char           ethAddress[LEN_ETHERNET_ADDRESS];
   u_char           lastEthAddress[LEN_ETHERNET_ADDRESS]; /* used for remote addresses */
@@ -842,11 +843,12 @@
   char             hostNumIpAddress[20] /* xxx.xxx.xxx.xxx */, *dnsDomainValue, *dnsTLDValue;
   u_int8_t         network_mask;    /* IPv6 notation e.g. /24 */
   int8_t           known_subnet_id; /* UNKNOWN_SUBNET_ID if the host does not belong to a known subnet */
-  char             *hwModel, *description, *community, *ip2ccValue, *fingerprint;
+  char             *hwModel, *description, *community, *fingerprint;
   char             hostResolvedName[MAX_LEN_SYM_HOST_NAME];
   short            hostResolvedNameType;
   u_short          minTTL, maxTTL; /* IP TTL (Time-To-Live) */
   struct timeval   minLatency, maxLatency;
+  GeoIPRecord      *geo_ip;
 
   TrafficCounter   greSent, greRcvd, greEfficiencySent, greEfficiencyRcvd,
     grePktSent, grePktRcvd, lastGrePktSent, lastGrePktRcvd;
@@ -1999,15 +2001,6 @@
 };
 #endif /* HAVE_GETOPT_H */
 
-/* Courtesy of Andreas Pfaller <apfaller@yahoo.com.au> */
-typedef struct IPNode {
-  struct IPNode *b[2];
-  union {
-    char cc[4]; /* Country */
-    u_short as; /* AS */
-  } node;
-} IPNode;
-
 /* *************************************************************** */
 
 typedef enum {
@@ -2262,7 +2255,7 @@
   /*
    * Control mutexes
    */
-  PthreadMutex gdbmMutex;
+  PthreadMutex gdbmMutex, portsMutex;
   PthreadMutex tcpSessionsMutex[NUM_SESSION_MUTEXES];
   PthreadMutex fcSessionsMutex; /* One mutex should be enough */
   PthreadMutex purgePortsMutex;
@@ -2468,14 +2461,6 @@
     numVendorLookupFoundMulticast,
     numVendorLookupFoundLAA;
 
-  /* Country flags */
-  IPNode *countryFlagHead;
-  int  ipCountryMem, ipCountryCount;
-
-  /* AS */
-  IPNode *asHead;
-  int    asMem, asCount;
-
   /* Memory usage */
   int piMem, ippmtmMem;
 
@@ -2499,8 +2484,7 @@
       queueBufferCount,
       processBufferInit,
       processBufferCount;
-  float qmaxDelay,
-        pmaxDelay;
+  float qmaxDelay, pmaxDelay;
 #endif
 
 #ifdef PARM_ENABLE_EXPERIMENTAL
@@ -2510,5 +2494,9 @@
   u_int8_t  calculateEfficiency;
   /* If the traffic is divided in cells (e.g. ATM, cell payload is 47 bytes) this is the cell lenght */
   u_int16_t cellLength; 
+
+  /* GeoIP */
+  GeoIP *geo_ip_db, *geo_ip_asn_db;
+
 } NtopGlobals;
 
diff -uNr ntop-3.3.8/hash.c ntop-3.3.9/hash.c
--- ntop-3.3.8/hash.c	2008-08-05 12:06:31.000000000 +0200
+++ ntop-3.3.9/hash.c	2008-11-07 12:04:30.000000000 +0100
@@ -472,11 +472,11 @@
   host->dnsDomainValue = NULL;
   if(host->dnsTLDValue != NULL) free(host->dnsTLDValue);
   host->dnsTLDValue = NULL;
+  if(host->hostASDescr != NULL) free(host->hostASDescr);
   if(host->description != NULL) free(host->description);
   if(host->hwModel != NULL) free(host->hwModel);
   if(host->community != NULL) free(host->community);
-  if(host->ip2ccValue != NULL) free(host->ip2ccValue);
-  host->ip2ccValue = NULL;
+  if(host->geo_ip) GeoIPRecord_delete(host->geo_ip);
 
   /* ********** */
   /*
Dateien ntop-3.3.8/html/multihomed.gif und ntop-3.3.9/html/multihomed.gif sind verschieden.
Dateien ntop-3.3.8/html/multihomed.png und ntop-3.3.9/html/multihomed.png sind verschieden.
diff -uNr ntop-3.3.8/http.c ntop-3.3.9/http.c
--- ntop-3.3.8/http.c	2008-10-02 12:54:15.000000000 +0200
+++ ntop-3.3.9/http.c	2008-11-07 01:56:35.000000000 +0100
@@ -546,7 +546,8 @@
 		  "	[null,'Summary',null,null,null,\n"
 		  "		[null,'Traffic','/" CONST_TRAFFIC_STATS_HTML "',null,null],\n"
 		  "		[null,'Hosts','/" CONST_HOSTS_INFO_HTML "',null,null],\n"
-		  "		[null,'Network Load','/" CONST_SORT_DATA_THPT_STATS_HTML "',null,null],\n");
+		  "		[null,'Network Load','/" CONST_SORT_DATA_THPT_STATS_HTML "',null,null],\n"
+		  "		[null,'Hosts World Map','/" CONST_HOST_MAP "',null,null],\n");
   if(myGlobals.haveVLANs == TRUE)
     sendStringWOssi(
 		    "		[null,'VLAN Info','/" CONST_VLAN_LIST_HTML "',null,null],\n");
@@ -2178,8 +2179,11 @@
     storePrefsValue("globals.displayPolicy", tmp);
   }
 
-  if(pageName[0] == '\0')
+  if(pageName[0] == '\0') {
+    /* Default ntop entry page */
     strncpy(pageName, CONST_TRAFFIC_STATS_HTML, sizeof(CONST_TRAFFIC_STATS_HTML));
+    /* strncpy(pageName, CONST_HOST_MAP, sizeof(CONST_HOST_MAP)); */
+  }
 
   /* Generic w3c p3p request? force it to ours... */
   if(strncmp(pageName, CONST_W3C_P3P_XML, strlen(CONST_W3C_P3P_XML)) == 0)
@@ -3245,6 +3249,11 @@
       } else if(strncasecmp(pageName, CONST_PURGE_HOST, strlen(CONST_PURGE_HOST)) == 0) {
 	sendHTTPHeader(FLAG_HTTP_TYPE_HTML, 0, 1);
 	purgeHost(db_key);
+      } else if(strncasecmp(pageName, CONST_HOST_MAP, strlen(CONST_HOST_MAP)) == 0) {
+	sendHTTPHeader(FLAG_HTTP_TYPE_HTML, 0, 1);
+	printHTMLheader("Hosts World Map", NULL, 0);
+	create_host_map();
+	printTrailer = 1;
       } else if(strlen(pageName) > 5) {
 	char hostName[32];
 
diff -uNr ntop-3.3.8/iface.c ntop-3.3.9/iface.c
--- ntop-3.3.8/iface.c	2008-06-13 08:13:26.000000000 +0200
+++ ntop-3.3.9/iface.c	2008-11-05 15:52:33.000000000 +0100
@@ -39,13 +39,15 @@
 /* ************************************************* */
 
 static struct in6_addr *in6_cpy(struct in6_addr *dst, struct in6_addr *src) {
-  return memcpy(dst, src, sizeof(struct in6_addr));
+  memcpy(dst, src, sizeof(struct in6_addr));
+  return(dst);
 }
 
 /* ************************************************* */
 
 static struct in_addr *in4_cpy(struct in_addr *dst, struct in_addr *src) {
-  return memcpy(dst, src, sizeof(struct in_addr));
+  memcpy(dst, src, sizeof(struct in_addr));
+  return(dst);
 }
 
 /* ************************************************* */
diff -uNr ntop-3.3.8/initialize.c ntop-3.3.9/initialize.c
--- ntop-3.3.8/initialize.c	2008-09-15 23:42:02.000000000 +0200
+++ ntop-3.3.9/initialize.c	2008-12-03 23:00:22.000000000 +0100
@@ -25,8 +25,6 @@
 #include "ntop.h"
 #include "globals-report.h"
 
-static void initIPCountryTable(void); /* Forward */
-
 /*
  * calculate the domain name for this host
  */
@@ -209,66 +207,6 @@
 
 /* ******************************* */
 
-static void initIPCountryTable(void) {
-  u_char compressedFormat;
-  char buf[LEN_GENERAL_WORK_BUFFER];
-  FILE* fd;
-
-  myGlobals.ipCountryCount = 0;
-  if((myGlobals.countryFlagHead = malloc(sizeof(IPNode))) == NULL) {
-    traceEvent(CONST_TRACE_FATALERROR, "IP2CC: Unable to allocate table memory. Quitting...");
-    exit(4); /* Just in case */
-  }
-  myGlobals.ipCountryMem += sizeof(IPNode);
-
-  strcpy(myGlobals.countryFlagHead->node.cc, "***");
-
-  myGlobals.countryFlagHead->b[0]=NULL;
-  myGlobals.countryFlagHead->b[1]=NULL;
-
-  if (!myGlobals.runningPref.printFcOnly) {
-    fd=checkForInputFile("IP2CC",
-			 "IP address <-> Country Code mapping",
-			 CONST_P2C_FILE,
-			 NULL,
-			 &compressedFormat);
-      if(fd != NULL) {
-          char *strtokState, *cc, *ip, *prefix;
-          int numRead=0;
-
-          while(readInputFile(fd,
-                              "IP2CC",
-                              FALSE,
-                              compressedFormat,
-			      10000,
-                              buf, sizeof(buf),
-                              &numRead) == 0) {
-              if((cc=strtok_r(buf, ":", &strtokState))       == NULL) continue;
-              if((ip=strtok_r(NULL, "/", &strtokState))      == NULL) continue;
-              if((prefix=strtok_r(NULL, "\n", &strtokState)) == NULL) continue;
-
-              strtolower(cc);
-
-              if(addNodeInternal(xaton(ip), atoi(prefix), cc, 0) == NULL) {
-                traceEvent(CONST_TRACE_FATALERROR,
-                           "IP2CC: Insufficient memory to load table");
-                /* This isn't fatal of an itself, but we'll fail every malloc() from here on ... */
-                exit(5); /* Just in case */
-              }
-          }
-
-          myGlobals.ipCountryCount += numRead;
-      } else {
-          traceEvent(CONST_TRACE_WARNING,
-                     "IP2CC: Unable to read IP address <-> Country code mapping file (non-existant or no data)");
-          traceEvent(CONST_TRACE_INFO,
-                     "IP2CC: ntop will perform correctly but without this minor feature");
-      }
-  }
-}
-
-/* ******************************* */
-
 void createDeviceIpProtosList(int devIdx) {
   size_t len = (size_t)myGlobals.numIpProtosList*sizeof(TrafficCounter);
 
@@ -528,56 +466,40 @@
   myGlobals.sessionsCacheReused = 0;
 #endif
 
-  /*
-   * Process ASN file
-   */
-  numRead=0;
-  myGlobals.haveASN = FALSE;
-  if (!myGlobals.runningPref.printFcOnly) {
-      fd=checkForInputFile("ASN",
-                           "Autonomous System Number table",
-                           CONST_ASLIST_FILE,
-                           NULL,
-                           &compressedFormat);
-      if(fd != NULL) {
-          char *strtokState, *as, *ip, *prefix;
-
-          memset(&buf, 0, sizeof(buf));
-
-          myGlobals.asHead = malloc(sizeof(IPNode));
-          memset(myGlobals.asHead, 0, sizeof(IPNode));
-          myGlobals.asHead->node.as = 0;
-          myGlobals.asMem += sizeof(IPNode);
-
-          while(readInputFile(fd,
-                              "ASN",
-                              FALSE,
-                              compressedFormat,
-                              25000,
-                              buf, sizeof(buf),
-                              &numRead) == 0) {
-
-              if((as = strtok_r(buf, ":", &strtokState)) == NULL)  continue;
-              if((ip = strtok_r(NULL, "/", &strtokState)) == NULL)  continue;
-              if((prefix = strtok_r(NULL, "\n", &strtokState)) == NULL)  continue;
-
-              if(addNodeInternal(xaton(ip), atoi(prefix), NULL, atoi(as)) == NULL) {
-                traceEvent(CONST_TRACE_FATALERROR,
-                           "ASN: Insufficient memory to load table");
-                /* This isn't fatal of an itself, but we'll fail every malloc() from here on ... */
-                exit(6); /* Just in case */
-              }
-
-              myGlobals.asCount++;
-          }
-          traceEvent(CONST_TRACE_INFO, "ASN: ....Used %d KB of memory (%d per entry)",
-                     ((myGlobals.asMem+512)/1024), (int)sizeof(IPNode));
-          myGlobals.haveASN = TRUE;
-      } else
-          traceEvent(CONST_TRACE_NOISY, "ASN: ntop continues ok, but without ASN information.");
+  /* Initialize GeoIP databases */
+  for(i=0; myGlobals.configFileDirs[i] != NULL; i++) {
+    char path[256];
+    
+    safe_snprintf(__FILE__, __LINE__, path, sizeof(path),
+		  "%s%c%s",
+		  myGlobals.configFileDirs[i], CONST_PATH_SEP, GEO_IP_FILE);
+    revertSlashIfWIN32(path, 0);
+    if((myGlobals.geo_ip_db = GeoIP_open(path, GEOIP_CHECK_CACHE)) != NULL) {
+      traceEvent(CONST_TRACE_INFO, "GeoIP: loaded config file %s", path);
+      break;
+    }
   }
+  
+  if(myGlobals.geo_ip_db == NULL)
+    traceEvent(CONST_TRACE_ERROR, "GeoIP: unable to load file %s", GEO_IP_FILE);
+  
+  /* *************************** */
 
-  initIPCountryTable();
+  for(i=0; myGlobals.configFileDirs[i] != NULL; i++) {
+    char path[256];
+    
+    safe_snprintf(__FILE__, __LINE__, path, sizeof(path),
+		  "%s%c%s",
+		  myGlobals.configFileDirs[i], CONST_PATH_SEP, GEO_IP_ASN_FILE);
+    revertSlashIfWIN32(path, 0);
+    if((myGlobals.geo_ip_asn_db = GeoIP_open(path, GEOIP_CHECK_CACHE)) != NULL) {
+      traceEvent(CONST_TRACE_INFO, "GeoIP: loaded ASN config file %s", path);
+      break;
+    }
+  }
+  
+  if(myGlobals.geo_ip_asn_db == NULL)
+    traceEvent(CONST_TRACE_ERROR, "GeoIP: unable to load ASN file %s", GEO_IP_ASN_FILE);  
 }
 
 
@@ -787,6 +709,7 @@
  */
   createMutex(&myGlobals.logViewMutex);
   createMutex(&myGlobals.gdbmMutex);        /* data to synchronize thread access to db files */
+  createMutex(&myGlobals.portsMutex);       /* Avoid race conditions while handling ports */
 
   for(i=0; i<NUM_SESSION_MUTEXES; i++)
     createMutex(&myGlobals.tcpSessionsMutex[i]); /* data to synchronize TCP sessions access */
@@ -1241,15 +1164,14 @@
 
       strncat(workDevices,
               myGlobals.device[i].name,
-              (sizeof(workDevices) - strlen(workDevices) - hasSpace));
+              (mallocLen - strlen(workDevices) - hasSpace));
     }
   }
 
   if(myGlobals.runningPref.devices != NULL)
     free(myGlobals.runningPref.devices);
 
-  myGlobals.runningPref.devices = strdup(workDevices);
-  free(workDevices);
+  myGlobals.runningPref.devices = workDevices;
 
   /* ********************************************** */
 
@@ -1698,6 +1620,7 @@
   u_int mallocLen;
 #endif
   u_int deviceId = myGlobals.numDevices;
+  int i;
 
   traceEvent(CONST_TRACE_INFO, "Creating dummy interface, '%s'", ifName);
 
@@ -1721,7 +1644,7 @@
   myGlobals.device[deviceId].virtualDevice = 0;
   myGlobals.device[deviceId].activeDevice  = 0;
   myGlobals.device[deviceId].samplingRate =  myGlobals.runningPref.samplingRate;
-  calculateUniqueInterfaceName(deviceId);
+  calculateUniqueInterfaceName(deviceId); 
 
   if(myGlobals.otherHostEntry != NULL) {
     myGlobals.device[deviceId].hash_hostTraffic[OTHER_HOSTS_ENTRY] = myGlobals.otherHostEntry;
@@ -1754,5 +1677,14 @@
     memset(myGlobals.device[deviceId].tcpSession, 0, len);
   }
 
+  /* Allocate memory for dhcp stats */
+
+  for(i=0; i<myGlobals.numKnownSubnets; i++) {
+    myGlobals.device[deviceId].networkHost[i].protocolInfo = calloc(1, sizeof(ProtocolInfo));
+    myGlobals.device[deviceId].networkHost[i].protocolInfo->dnsStats = calloc(1, sizeof(ServiceStats));
+    myGlobals.device[deviceId].networkHost[i].protocolInfo->httpStats = calloc(1, sizeof(ServiceStats));
+    myGlobals.device[deviceId].networkHost[i].protocolInfo->dhcpStats = calloc(1, sizeof(DHCPStats));
+  }
+
   return(deviceId);
 }
diff -uNr ntop-3.3.8/INSTALL ntop-3.3.9/INSTALL
--- ntop-3.3.8/INSTALL	2008-10-02 12:54:15.000000000 +0200
+++ ntop-3.3.9/INSTALL	2008-12-03 23:00:22.000000000 +0100
@@ -2,7 +2,7 @@
 *************************
 
 Copyright (C) 1994, 1995, 1996, 1999, 2000, 2001, 2002, 2004, 2005,
-2006, 2007 Free Software Foundation, Inc.
+2006 Free Software Foundation, Inc.
 
 This file is free documentation; the Free Software Foundation gives
 unlimited permission to copy, distribute and modify it.
@@ -67,9 +67,6 @@
      all sorts of other programs in order to regenerate files that came
      with the distribution.
 
-  6. Often, you can also type `make uninstall' to remove the installed
-     files again.
-
 Compilers and Options
 =====================
 
